;************************
;****** Block Test ******
;*************************************************
;** Input:								**
;** BlkTest (Block Column), (Block Row)		**
;**									**
;** This subroutine will test the given block	**
;** to see if it is a bomb.				**
;** ALL it will do is test for a bomb. It		**
;** won't even branch accordingly			**
;*************************************************

BlkTest		macro				;<-- **START MACRO**
	
	move.w	\2,d1				;<-- Transfer the line number into d1
	move.w	\1,d3				;<-- Move the block number to test into d3
	jsr		BlkTestFunc

			endm				;<-- **END MACRO**

BlkTestFunc:
	move.l	#LvlData,a1		;<-- Put start of level data into a1
	mulu.w	#2,d1				;<-- Account for each line being 2 bytes not 1
							;** Note:	d1 now contains the actual offset 
							;** 		to the appropriate line of level
							;**		data

	add.w		d1,a1				;<-- Add the offset to the start of the level
							;	data
	move.w	#15,d0			;<-- Invert it to test the appropriate bit
	sub.w		d3,d0				;<-- by subtracting it from 15 
	move.w	(a1),d1			;<--	Move one actual line of level data into d1
	btst.l	d0,d1				;<-- Test the block.
	rts


;**************************
;****** Put Number 2 ******
;**************************************
;** Input Syntax:			     **
;** PutNum2 (screen x coordinate),   **
;** (screen y coordinate),(value to  **
;** put on screen)			     **
;** 		- or -			     **
;** PutNum2 X,Y,Value			     **
;** 						     **
;** This macro will numerize and     **
;** place the approprieate character **
;** on the screen at the X and Y     **
;** coordinates of your choice	     **
;**						     **
;** Note:					     **
;**   Named PutNum2 because it can   **
;** only handle 2 character values   **
;** (aka values 0-99)			     **
;**************************************

PutNum2		macro			;<-- ** START MACRO **
	
	move.w	\1,d0
	move.w	\2,d1
	move.w	\3,Temp3
	jsr		PutNum2Func
	WriteStr	\1,\2,#1,StrNum2;<-- Output the string and we're done!
			
			endm			;<-- ** END MACRO **
						;    Can't have any labels inside a macro
						;	because it inserts the code into your
						;	program every place it's called

PutNum2Func:
	move.w	#12,d2
	move.w	#8,d3
	move.w	#1,d4
	jsr		graphlib::fill
	move.l	#StrNum2,a0	;<-- Put the address of StrNum into a0
	move.w	Temp3,d0		;<-- Place the value into d0 so we can manipulate it
	move.l	d0,d1			;<-- Copy d0 into d1 for manipulation
	divu.w	#10,d1		;<-- Divide d1 by 10 to get the tens column number
	add.w		#48,d1		;<--	Convert to ascii valu of the character we want
	jsr		OneChar	
	move.b	d1,(a0)		;<-- Place char. into tens column of string
	jsr		OneChar2
	sub.w		#48,d1		;<-- Get it back to its ordinal value
	mulu.w	#10,d1		;<-- Now figure out how much to subtract from d0
	sub.w		d1,d0			;<-- d0 now has the number to put in the ones collumn
	add.w		#48,d0		;<-- Convert to ascii value of the number
	add.w		#1,a0			;<-- Add 1 to a0 to get second character in string
	move.b	d0,(a0)		;<-- Move the char into the string
	rts


;**************************
;****** Put Number 3 ******
;**************************************
;** Input Syntax:			     **
;** PutNum3 (screen x coordinate),   **
;** (screen y coordinate),(value to  **
;** put on screen)			     **
;** 		- or -			     **
;** PutNum3 X,Y,Value			     **
;** 						     **
;** This macro will numerize and     **
;** place the approprieate character **
;** on the screen at the X and Y     **
;** coordinates of your choice	     **
;**						     **
;** Note:					     **
;**   Named PutNum3 because it can   **
;** only handle 3 character values   **
;** (aka values 0-999)               **
;**************************************

PutNum3		macro			;<-- ** START MACRO **
	
	move.w	\1,d0			;<-- X
	move.w	\2,d1			;<-- Y
	move.w	\3,Temp3
	jsr		PutNum3Func
	WriteStr	\1,\2,#1,StrNum3;<-- Output the string and we're done!

			endm			;<-- ** END MACRO **
						;    Can't have any labels inside a macro
						;	because it inserts the code into your
						;	program every place it's called
PutNum3Func:
;**** ERASE PREVIOUS NUMBER
	move.w	#17,d2		;<-- Width minus 1
	move.w	#7,d3			;<-- Height
	move.w	#1,d4			;<-- Color (1 = White)
	jsr		graphlib::fill	;<-- Draw a box to erase previous number
;**** SETUP a0 AND d0
	move.l	#StrNum3,a0	;<-- Put the address of StrNum into a0
	move.w	Temp3,d0		;<-- Place the value into d0 so we can manipulate it
	move.l	d0,d1			;<-- Copy d0 into d1 for manipulation
;**** 100's COLLUMN
	divu.w	#100,d1		;<-- Divide d1 by 100 to get the hundreds
						;	 column value
	add.w		#48,d1		;<--	Convert to ascii valu of the character we want
	jsr		OneChar		;<-- If its zero, replace it with a space
	move.b	d1,(a0)		;<-- Place char. into tens column of string
	jsr		OneChar2		;<-- If its a space, replace it with zero
;**** 10's COLLUMN
	sub.w		#48,d1		;<-- Get it back to its ordinal value
	mulu.w	#100,d1		;<-- Now figure out how much to subtract from d0
	sub.w		d1,d0			;<-- d0 is now ready for the tens collumn
	move.w	d0,d1			;<-- Move d0 into d1 for manipulation
	divu.w	#10,d1		;<-- Get the tens number 
	add.w		#48,d1		;<-- Convert to ascii value of the number
	jsr		TwoChar
	add.w		#1,a0			;<-- Add 1 to a0 to get second character in string
	move.b	d1,(a0)		;<-- Move the char into the string
	jsr		TwoChar2
;**** 1's COLLUMN
	sub.w		#48,d1		;<-- Get d1 back into ordinal form
	mulu.w	#10,d1		;<-- Now figure out how much to subtract from d0
	sub.w		d1,d0			;<-- d0 is now ready for the ones collumn
	add.w		#48,d0		;<-- Put d0 into
	add.w		#1,a0			;<-- Get next char in string
	move.b	d0,(a0)		;<-- Move d0 onto the string
	rts


OneChar:
	cmp.w		#48,d1		;<-- Is it ascii zero?
	beq		ZeroToSpace	;<-- If so, go to "Change Zero to a Space"
	rts					;<-- Otherwise, return


OneChar2:					;<-- One Charater Part II: The Revenge of d1
	cmp.w		#32,d1		;<-- Did I change d1?
	beq		SpaceToZero	;<-- If so, change it back, damn it!!
	rts					;<-- Otherwise, return

TwoChar:
	move.b	(a0),d2
	cmp.b		#32,d2		;<-- Is the first character blank?
	beq		\IsD1Zero		;<-- If so, branch to "Is d1 zero"
	rts					;<-- return

\IsD1Zero
	cmp.w		#48,d1		;<-- Is d1 ascii zero
	beq		ZeroToSpace	;<-- If so, convert it to a space character
	rts					;<-- If not, return

TwoChar2:
	cmp.w		#32,d1		;<-- Did I change d1?
	beq		SpaceToZero	;<-- If so, change it back
	rts					;<-- If not, return
	
ZeroToSpace:
	move.w	#32,d1		;<-- Change ascii Zero to ascii Space
	rts					;<-- And Return

SpaceToZero:
	move.w	#48,d1		;<-- It's changed
	rts					;<-- Now to go back from whence we cameth

;****************
;**** String ****
;**********************************
;** Prepares the screen for, and **
;** prints a string given:		 **
;** 						 **
;** 1) X coordinate			 **
;** 2) Y coordinate			 **
;** 3) Length of string		 **
;** 4) Color				 **
;** 5) Address of string		 **
;**********************************

String		macro

	move.w	\1,d0
	move.w	\2,d1
	move.w	\3,d2
	jsr		StringFunc
	WriteStr	\1,\2,\4,\5

			endm

StringFunc:
	sub.w		#1,d1
	mulu.w	#6,d2
	sub.w		#1,d2
	move.w	#8,d3
	move.w	#1,d4
	jsr		graphlib::fill
	rts

;*****************
;**** StringA ****
;**********************************
;** Prepares the screen for, and **
;** prints a string given:		 **
;** 						 **
;** 1) X coordinate			 **
;** 2) Y coordinate			 **
;** 3) Length of string		 **
;** 4) Color				 **
;** 5) An (a0, a1, a2, a3, etc.) **
;**********************************

StringA		macro

	move.w	\1,d0
	move.w	\2,d1
	move.w	\3,d2
	jsr		StringAFunc
	WriteStrA	\1,\2,\4,\5

			endm

StringAFunc:
	sub.w		#1,d1
	mulu.w	#6,d2
	sub.w		#1,d2
	move.w	#8,d3
	move.w	#1,d4
	jsr		graphlib::fill
	rts

;******************
;**** Square 2 ****
;**********************************
;** Draws an empty square on the **
;** screen with walls 2 pixels   **
;** thick given:                 **
;** 						 **
;** 1) X coordinate			 **
;** 2) Y coordinate			 **
;** 3) Width				 **
;** 4) Height				 **
;**********************************

Square2		macro

	move.w	\1,d0
	move.w	\2,d1
	move.w	\3,d2
	move.w	\4,d3
	jsr		Square2Func

			endm

Square2Func:
	sub.w		#1,d2
	sub.w		#1,d3
	move.w	#2,d4
	jsr		graphlib::fill
	add.w		#2,d0
	add.w		#2,d1
	sub.w		#4,d2
	sub.w		#4,d3
	move.w	#1,d4
	jsr		graphlib::fill
	rts

;****************************
;**** Clear Screen Macro ****
;*****************************************************
;** Clears the screen from the given y-coor on down **
;*****************************************************

ClearScreenM	macro

	move.w	\1,Temp1
	bsr		ClearScreenMFunc
			
			endm

ClearScreenMFunc:
	move.l	#doorsos::main_lcd,a0	
	move.w	Temp1,d1
	mulu.w	#30,d1
	add.w		d1,a0
	move.w	#1919,d0
	move.w	Temp1,d1
	mulu.w	#15,d1
	sub.w		d1,d0
	bsr		ClearLoop
	rts
			

ClearLoop:
	clr.w		(a0)+				
	dbf.w		d0,ClearLoop		
	rts	

;********************
;**** Enter Name ****
;****************************
;** ?????????????????????? **
;****************************

EnterName		macro

	move.l	\1,a0

			endm
