;*******************
;**** Main Menu ****
;****************************************
;** The main menu is setup as follows: **
;** 			                       **
;** Play					       **
;**   -- Main game loop		       **
;** Options                            **
;**   -- Number of Bombs		       **
;**   -- Speed                         **
;** High Scores				       **
;**   -- View high scores		       **
;** Help					       **
;**   -- Show Help Screen              **
;** Quit					       **
;**   -- Exit Game			       **
;**                                    **
;****************************************

MainMenu:
	Square2	#30,#0,#101,#13			;<-- Title Box
	String	#32,#3,#16,#2,StrTitle	;<-- Display Title

	Square2	#44,#16,#72,#50			;<-- Main Menu Box
	String	#47,#19,#11,#0,StrPlay	;<-- Display The Menu Items
	String	#47,#28,#11,#2,StrOptions
	String	#47,#37,#11,#2,StrHighScores
	String	#47,#46,#11,#2,StrHelp
	String	#47,#55,#11,#2,StrQuit
	move.w	#0,MMenuCur
	move.w	#0,OldMMenuCur
	jmp		MainMenuKeyB

Play:
	move.w	#0,OldX				;<-- All these next lines initialize
	move.w	#100,OldY				;	  various variables. See the bottom
	move.w	#16,CurX				;	  of main file for their declarations
	move.w	#16,CurY				;	  and descriptions
	move.w	MaxFlags,Flags
	move.b	#0,WinFlag				
	move.b	#0,Update
	move.b	#0,Ticks
	move.w	#0,Seconds
	jsr		ClearScreen			;<-- Clear the screen
	jsr 		DisplayBoard			;<-- Puts the game board on screen
	jsr		MakeLevel				;<-- Makes the Level Data and resets
								;	the Win Data and Flag Data
	jsr		DispSec
	move.b	#0,Ticks				;<-- Resets the timer
	move.w	#0,Seconds				;<-- Resets the clock
	jmp 		KeyLoop				;<-- Jumps to the main game loop

Options:
	ClearScreenM #16
	Square2	#20,#16,#120,#42
	String	#23,#19,#19,#0,StrONumBombs
	PutNum2	#124,#19,NumBombs
	String	#23,#28,#19,#2,StrOSpeed
	PutNum2	#124,#28,Speed
	String	#23,#37,#19,#2,StrODefault
	String	#23,#46,#19,#2,StrOReturn
	Square2	#20,#60,#120,#24
	String	#23,#63,#19,#2,StrOHelp1
	String	#23,#72,#19,#2,StrOHelp2
	move.w	#0,OldOptCur
	move.w	#0,OptCur

\OptKeyB
	tst.w		(doorsos::kb_vars+$1c)
	beq		\OptKeyB
	move.w	(doorsos::kb_vars+$1e),d0
	clr.w		(doorsos::kb_vars+$1c)	;<<*** DON'T FORGET TO CLEAR $1c not $1e
	cmp.w		#264,d0
	beq		\OptEsc
	cmp.w		#KEY_UP,d0
	beq		\OptUp
	cmp.w		#KEY_DOWN,d0
	beq		\OptDown
	cmp.w		#KEY_LEFT,d0
	beq		\OptLeft
	cmp.w		#KEY_RIGHT,d0
	beq		\OptRight
	cmp.w		#13,d0
	beq		\OptSelect
	bra		\OptKeyB

\OptEsc
	move.w	OptCur,OldOptCur
	move.w	#3,OptCur
	jsr		\OptDispCur
	bra		\OptKeyB

\OptUp
	cmp.w		#0,OptCur
	bne		\OptMoveUp
	move.w	#0,OldOptCur
	move.w	#3,OptCur
	jsr		\OptDispCur
	bra		\OptKeyB
\OptMoveUp	
	move.w	OptCur,OldOptCur
	sub.w		#1,OptCur
	jsr		\OptDispCur
	bra		\OptKeyB

\OptDown
	cmp.w		#3,OptCur
	bne		\OptMoveDown
	move.w	#3,OldOptCur
	move.w	#0,OptCur
	jsr		\OptDispCur
	bra		\OptKeyB
\OptMoveDown
	move.w	OptCur,OldOptCur
	add.w		#1,OptCur
	jsr		\OptDispCur
	bra		\OptKeyB

\OptLeft
	cmp.w		#0,OptCur
	beq		\OptBombsLess
	cmp.w		#1,OptCur
	beq		\OptSpeedLess
	bra		\OptKeyB

\OptBombsLess
	cmp.w		#0,NumBombs
	bne		\OptBombsLessNext
	move.w	#99,NumBombs
	move.w	#99,MaxFlags
	bra		\OptBombsLessEnd
\OptBombsLessNext
	sub.w		#1,NumBombs
	sub.w		#1,MaxFlags
\OptBombsLessEnd
	PutNum2	#124,#19,NumBombs
	bra		\OptKeyB

\OptSpeedLess
	cmp.w		#1,Speed
	bne		\OptSpeedLessNext
	move.w	#99,Speed
	bra		\OptSpeedLessEnd
\OptSpeedLessNext
	sub.w		#1,Speed
\OptSpeedLessEnd
	PutNum2	#124,#28,Speed
	bra		\OptKeyB

\OptRight
	cmp.w		#0,OptCur
	beq		\OptBombsMore
	cmp.w		#1,OptCur
	beq		\OptSpeedMore
	bra		\OptKeyB

\OptBombsMore
	cmp.w		#99,NumBombs
	bne		\OptBombsMoreNext
	move.w	#0,NumBombs
	move.w	#0,MaxFlags
	bra		\OptBombsMoreEnd
\OptBombsMoreNext
	add.w		#1,NumBombs
	add.w		#1,MaxFlags
\OptBombsMoreEnd
	PutNum2	#124,#19,NumBombs
	bra		\OptKeyB

\OptSpeedMore
	cmp.w		#99,Speed
	bne		\OptSpeedMoreNext
	move.w	#1,Speed
	bra		\OptSpeedMoreEnd
\OptSpeedMoreNext
	add.w		#1,Speed
\OptSpeedMoreEnd
	PutNum2	#124,#28,Speed
	bra		\OptKeyB

\OptSelect
	cmp.w		#2,OptCur
	beq		\OptDefault
	cmp.w		#3,OptCur
	beq		\OptEnd
	bra		\OptKeyB

\OptDefault
	move.w	#15,NumBombs
	move.w	#15,MaxFlags
	move.w	#18,Speed
	PutNum2	#124,#19,NumBombs
	PutNum2	#124,#28,Speed
	bra		\OptKeyB

\OptEnd
	jsr		ClearScreen
	bra		MainMenu

\OptDispCur:
	move.l	#StrONumBombs,a0
	move.w	OldOptCur,d5
	mulu.w	#20,d5
	add.w		d5,a0
	move.w	OldOptCur,d5
	mulu.w	#9,d5
	add.w		#19,d5
	StringA	#23,d5,#19,#2,a0

	move.l	#StrONumBombs,a0
	move.w	OptCur,d5
	mulu.w	#20,d5
	add.w		d5,a0
	move.w	OptCur,d5
	mulu.w	#9,d5
	add.w		#19,d5
	StringA	#23,d5,#19,#0,a0
	PutNum2	#124,#19,NumBombs
	PutNum2	#124,#28,Speed
	rts	

HighScores:
	ClearScreenM #16
	Square2	#5,#16,#150,#68
	String	#8,#19,#20,#2,StrHigh1
	PutNum3	#133,#19,High1
	String	#8,#28,#20,#2,StrHigh2
	PutNum3	#133,#28,High2
	String	#8,#37,#20,#2,StrHigh3
	PutNum3	#133,#37,High3
	String	#8,#46,#20,#2,StrHigh4
	PutNum3	#133,#46,High4
	String	#8,#55,#20,#2,StrHigh5
	PutNum3	#133,#55,High5
	String	#8,#64,#19,#2,StrHReset
	String	#8,#73,#19,#0,StrHReturn
	move.w	#1,HSCur
	
\HSKeyB
	tst.w		(doorsos::kb_vars+$1c)
	beq		\HSKeyB
	move.w	(doorsos::kb_vars+$1e),d0
	clr.w		(doorsos::kb_vars+$1c)	;<<*** DON'T FORGET TO CLEAR $1c not $1e
	cmp.w		#264,d0
	beq		\HSEsc
	cmp.w		#KEY_UP,d0
	beq		\HSChange
	cmp.w		#KEY_DOWN,d0
	beq		\HSChange
	cmp.w		#13,d0
	beq		\HSSelect
	bra		\HSKeyB

\HSEsc
	move.w	#1,HSCur
	jsr		\HSDispCur
	bra		\HSKeyB

\HSChange
	move.w	#1,d0
	sub.w		HSCur,d0
	move.w	d0,HSCur
	jsr		\HSDispCur
	bra		\HSKeyB

\HSDispCur
	tst.w		HSCur
	beq		\HSCur0
	String	#8,#64,#19,#2,StrHReset
	String	#8,#73,#19,#0,StrHReturn
	rts	
\HSCur0
	String	#8,#64,#19,#0,StrHReset
	String	#8,#73,#19,#2,StrHReturn
	rts

\HSSelect
	tst.w		HSCur
	bne		\HSEnd
	move.l	#StrHighDefault,a0
	move.l	#StrHigh1,a1
	move.l	#StrHigh2,a2
	move.l	#StrHigh3,a3
	move.l	#StrHigh4,a4
	move.l	#StrHigh5,a5
	move.w	#4,d0
\HSCopyLoop
	move.l	(a0),(a1)+
	move.l	(a0),(a2)+
	move.l	(a0),(a3)+
	move.l	(a0),(a4)+
	move.l	(a0)+,(a5)+
	dbf.w		d0,\HSCopyLoop
	
	move.w	HighDefault,High1
	move.w	HighDefault,High2
	move.w	HighDefault,High3
	move.w	HighDefault,High4
	move.w	HighDefault,High5

	bra		HighScores
			
\HSEnd
	jsr		ClearScreen
	bra		MainMenu

Help:
	ClearScreenM #16
	Square2	#5,#16,#150,#78
	String	#8,#19,#24,#2,StrHLine1
	String	#8,#28,#24,#2,StrHLine2
	String	#8,#37,#24,#2,StrHLine3
	String	#8,#46,#24,#2,StrHLine4
	String	#8,#55,#24,#2,StrHLine5
	String	#8,#64,#24,#2,StrHLine6
	String	#8,#73,#24,#2,StrHLine7
	String	#8,#82,#24,#2,StrHLine8
	jsr		Wait
	jsr		ClearScreen
	bra		MainMenu

Quit:
	jmp		Ending

MainMenuKeyB:
	tst.w		(doorsos::kb_vars+$1c)
	beq		MainMenuKeyB
	move.w	(doorsos::kb_vars+$1e),d0
	clr.w		(doorsos::kb_vars+$1c)	;<<*** DON'T FORGET TO CLEAR $1c not $1e
	cmp.w		#264,d0
	beq		\MainMenuEsc
	cmp.w		#KEY_UP,d0
	beq		\MainMenuUp
	cmp.w		#KEY_DOWN,d0
	beq		\MainMenuDown
	cmp.w		#13,d0
	beq		\MainMenuSelect
	bra		MainMenuKeyB

\MainMenuEsc
	move.w	MMenuCur,OldMMenuCur
	move.w	#4,MMenuCur
	jsr		DispMainMenuCur
	bra		MainMenuKeyB

\MainMenuUp
	cmp.w		#0,MMenuCur
	bne		\MoveUp
	move.w	#0,OldMMenuCur
	move.w	#4,MMenuCur
	jsr		DispMainMenuCur
	bra		MainMenuKeyB
\MoveUp
	move.w	MMenuCur,OldMMenuCur
	sub.w		#1,MMenuCur
	jsr		DispMainMenuCur
	bra		MainMenuKeyB

\MainMenuDown
	cmp.w		#4,MMenuCur
	blt		\MoveDown
	move.w	#4,OldMMenuCur
	move.w	#0,MMenuCur
	jsr		DispMainMenuCur
	bra		MainMenuKeyB
\MoveDown
	move.w	MMenuCur,OldMMenuCur
	add.w		#1,MMenuCur
	jsr		DispMainMenuCur
	bra		MainMenuKeyB

\MainMenuSelect
	cmp.w		#0,MMenuCur
	beq		Play
	cmp.w		#1,MMenuCur
	beq		Options
	cmp.w		#2,MMenuCur
	beq		HighScores
	cmp.w		#3,MMenuCur
	beq		Help
	cmp.w		#4,MMenuCur
	beq		Quit
	bra		MainMenuKeyB

DispMainMenuCur:
	move.l	#StrPlay,a0
	move.w	OldMMenuCur,d5
	mulu.w	#12,d5
	add.w		d5,a0
	move.w	OldMMenuCur,d5
	mulu.w	#9,d5
	add.w		#19,d5
	StringA	#47,d5,#11,#2,a0

	move.l	#StrPlay,a0
	move.w	MMenuCur,d5
	mulu.w	#12,d5
	add.w		d5,a0
	move.w	MMenuCur,d5
	mulu.w	#9,d5
	add.w		#19,d5
	StringA	#47,d5,#11,#0,a0
	rts	

		