TimerSetup:
	move.b	#$b2,($600017)		;<-- Initialize timer rate. $b2 is 18Hz,
							;	which is the default value anyway
	move.w	#$700,d0			;<-- $700 = %0000 0111 0000 0000
	trap		#1				;<-- Set the interrupt mask. Uses the
							;	bits 10,9,8 in d0 to set the mask. 
							;	Omly Auto-Interrupts greater than 
							;	the mask value are called. Thus, 
							;	if the mask value is 111, its 
							;	greatest value and the one we are
							;	using, then no auto-interrupts
							;	are called.
	bclr.b	#2,($600001)		;<-- Prevent protected memory violation
	move.l	($74),OldAutoInt5	;<-- Save the old address of auto-interrupt 5
	move.l	#TimerInt,($74)		;<-- Insert OUR auto-interrupt #5 address
	bset.b	#2,($600001)		;<-- Reinstate the memory protection
	trap		#1				;<-- Reset the Interrupt mask (see docs)
	rts						;<-- Our job of setting up the timer code 
							;	is now complete.
TimerRemoval:
	move.w	#$700,d0			;<-- Don't let unruly interrupts interrupt
	trap		#1				;<-- our task
	bclr.b	#2,($600001)		;<-- Don't cause a memory violation
	move.l	OldAutoInt5,($74)	;<-- Restore the old address
	bset.b	#2,($600001)		;<-- Reinstate memory protection
	rts

TimerInt:
	move.l	d0,-(a7)
	add.b		#1,Ticks			;<-- Our counter.
	move.w	Speed,d0			;<-- Variable Speed for the clock
	cmp.b		Ticks,d0			;<-- The interrupt runs at 18Hz. Thus,
							;	every 18 ticks is a second.
	bne		Done				;<-- If not on the 18, then we're done
	move.b	#0,Ticks			;<-- Reset the ticks counter.
	move.b	#1,Update			;<-- The seconds timer need to be updated
Done:
	move.l	(a7)+,d0
	move.l	OldAutoInt5,-(a7)	;<-- Push the old interrupt address onto 
							;	the stack so that it can run when 
							;	we're done, thus allowing internal
							;	calculator timer routines to be 
							;	updated (APD, screen refresh, etc.)
	rts						;<-- And we're done here.
